package ANALYZE;
#
#This file is part of NNIPF(Version 0.03-beta):SPAM mail filtering software
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

sub IsPrivate{
my ($OIP) = @_;
$res = 0;
if (($OIP =~ /^10\.[0-9]+\.[0-9]+\.[0-9]+/)||
    ($OIP =~ /^172\.(16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31)\.[0-9]+\.[0-9]+/)||
    ($OIP =~ /^192\.168\.[0-9]+\.[0-9]+/ )) {$res=1;}
return $res;
}


#############
sub IpDictMatch{
 ($query,$Dict, $Flg) = @_;
 @qaddr=split(/\./,$query);
 $dir=$Dict;
 for ($i=0, $match=0, $flag=1; $i<4; $i++){
        if (-e ($filename=sprintf("%s/%s",$dir,$qaddr[$i])) ){
	  $fc=0;
	  if ($Flg){
	    if (-e ($counter=sprintf("%s/Count",$filename))){
	       open(INc, $counter);
	       while(<INc>) {$count=$_;}
	       close(INc);
	       unlink($counter);
	       $count+=1;
	    }else{$count=1;}
	    open(OUTc, ">$counter");
	    print(OUTc $count);
	    close(OUTc);
	  }
	}elsif ($flag) {
	     $flag=0;
	     opendir DH, $dir or die "$dir:$!";
	     $fc=256;
	     while (my $file = readdir DH) {  
       		next if $file =~ /^\.{1,2}$/;
		if (abs($file-$qaddr[$i]) < $fc) {
			$fc=abs($file-$qaddr[$i]);
	        }
	     }
        }else{$fc=256;}
	$match=$match*256+$fc;
	$dir=$filename;
        }
 return $match;
}

sub IpDictAdd{
 ($query,$Dict) = @_;
 @qaddr=split(/\./,$query);
 $filename=$Dict;

 for ($i=0; $i<4; $i++){
    $filename=sprintf("%s/%s",$filename,$qaddr[$i]);
    if (!-e $filename ) {
	mkdir($filename);
    }

   if (-e ($counter=sprintf("%s/Count",$filename))){
	     open(INc, $counter);
	     while(<INc>) {$count=$_;}
	     close(INc);
   }else{$count=1;}
   open(OUTc, ">$counter");
   print(OUTc $count);
   close(OUTc);
 }
}

sub IpDictRemove{
 ($query,$Dict) = @_;
 $query =~ s/\./\//g;
 $dir=$Dict . "/" . $query;

 $prevfc=0;
 $prevdir=$dir;
 for ($i=0; $i<4; $i++){
	opendir DH, $dir or die "$dir:$!";
	$fc=0;
	while (my $file = readdir DH) {  
       		next if $file =~ /^\.{1,2}$/;
		$fc++;
		$file = $dir . "/" . $file; 
		if ( -f $file ) {unlink($file);$fc--;}
		elsif (($file eq $prevdir)&&(-d $file)&&($prevfc eq 0))
						{rmdir($file);$fc--;}
	}
	$prevdir = $dir;
	$prevfc = $fc;
	$dir=substr($dir,0,rindex($dir,"/"));
	closedir DH;
 }
}

sub IpDictAddExclusive{
my ($OIP, $DICT1, $DICT2) = @_;
	IpDictAdd($OIP,$DICT1);
	if (IpDictMatch($OIP,$DICT2,0) eq 0) {
		IpDictRemove($OIP,$DICT2);
	}
}
 
sub components{
my ($str)=@_;

my $OIP="";
my $DIP="";
my $ONAME="";
my $DNAME="";
my $ISHELO=0;

### declared IP or name
  @h=split(/ /,$str);
  if ($h[0] =~ /[^0-9]*([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)[^0-9]*/) {
# declared IP
  $DIP =$1;
  }else{
# declared Name
  $DNAME = $h[0];
 }
### OFFICIAL IP or name
  if ($str =~ /.*\[([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)\].*/) {
  $OIP =$1;
  }

  $s = index($h[1],"\(")+1;
  if(($e= rindex($h[1],"\[")-1)<0) {$e=length($h[1]);}
  $ONAME = substr($h[1],$s,$e);
  if ($ONAME eq "HELO") {
  $ISHELO=1;
  if ($h[2] =~ /[^0-9]*([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)[^0-9]*/) {
        $DIP = $1;
        }else{
        $ONAME = "";
#substr($h[2],0,index($h[2],")"));
        }
  if  ($h[3] =~ /[^0-9]*([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)[^0-9]*/) {
        $OIP = $1;
   }
  }

 return ($OIP, $DIP, $ONAME, $DNAME, $ISHELO);
}
#############
sub analyze{
my ($str,$FLAG,$BADIP,$GOODIP) = @_;


($OIP, $DIP, $ONAME, $DNAME, $ISHELO) = components($str);

### Check IP address $OIP
$Bip = IpDictMatch($OIP,$BADIP,0);
$Gip = IpDictMatch($OIP,$GOODIP,0);
$Bad= Bratio($Gip,$Bip);
if ($FLAG) {print "Bip=$Bip\n", "Gip=$Gip\n", "IPmatch=$Bad\n";}
#######
$SCORE=( int($Bad*100));
if ($FLAG) {print "SCORE=",$SCORE, "\n\n";} else {return $SCORE;}
}

sub Bratio{
my ($Dg, $Db) = @_;
if ($Dg+$Db eq 0) {$eps=1;}else{$eps=0;}
return $Dg/($Dg+$Db+$eps);
}
1;
